﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace DynamicallyModRowColorByValue99895
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.Load += new EventHandler(Form1_Load);
            this.ultraGrid1.AfterCellUpdate += new Infragistics.Win.UltraWinGrid.CellEventHandler(ultraGrid1_AfterCellUpdate);
            this.ultraGrid1.InitializeRow += new InitializeRowEventHandler(ultraGrid1_InitializeRow);
        }

        void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            //When the row is being initialized, check the value of each of its cells
            foreach(UltraGridCell cell in e.Row.Cells)
                //If the cell's text is "Y" AND that cell also resides within Column "B", modify the row's background color to red
                if ((cell.Text == "Y") && (cell.Column.Key == "B")) cell.Row.Appearance.BackColor = Color.Red;
        }

        //Check the text of discrete cells after they are modified by the user
        void ultraGrid1_AfterCellUpdate(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            //If the cell's text is "Y" AND that cell also resides within Column "B", modify the row's background color to red
            if ((e.Cell.Text == "Y") && (e.Cell.Column.Key == "B")) e.Cell.Row.Appearance.BackColor = Color.Red;
        }

        void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = GetData();
            ultraGrid1.DataBind();
        }

        //Populate the UltraGrid with some sample data
        public DataTable GetData()
        {
            DataTable dt = new DataTable();

            dt.Columns.AddRange(new DataColumn[] { new DataColumn("A", typeof(string)), new DataColumn("B", typeof(string))});

            for(int i = 0; i < 9; i++)
            {
                if (i == 5)
                    dt.Rows.Add(i.ToString(), "Y");
                if(i == 3)
                    dt.Rows.Add("Y", (i + 10).ToString());
                else
                {
                    dt.Rows.Add(i.ToString(), (i + 10).ToString());  
                }
            }

            return dt;
        }
    }
}
